package net.wanji.web.controller.scheme;

import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiResponse;
import io.swagger.annotations.ApiResponses;
import net.wanji.feign.pojo.result.JsonViewObject;
import net.wanji.web.dto.CrossIdDTO;
import net.wanji.web.dto.SaveLightsInfoDTO;
import net.wanji.web.service.scheme.impl.LightsConfigServiceImpl;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;

import javax.ws.rs.core.MediaType;

/**
 * @author Kent HAN
 * @date 2022/12/20 10:14
 */
/// 弃用，与CrossConfigController合并
// @Api(value = "LightsConfigController", description = "方案管理-灯组配置")
// @RequestMapping("/lightsConfig")
// @RestController
public class LightsConfigController {
    private final LightsConfigServiceImpl lightsConfigService;

    public LightsConfigController(LightsConfigServiceImpl lightsConfigService) {
        this.lightsConfigService = lightsConfigService;
    }

    @ApiOperation(value = "保存灯组配置", notes = "保存灯组配置", response = JsonViewObject.class,
            produces = MediaType.APPLICATION_JSON, consumes = MediaType.APPLICATION_JSON)
    @PostMapping(value = "/saveLightsInfo",
            produces = MediaType.APPLICATION_JSON, consumes = MediaType.APPLICATION_JSON)
    @ApiResponses({
            @ApiResponse(code = 200, message = "OK", response = JsonViewObject.class),
    })
    public JsonViewObject saveLightsInfo(@RequestBody SaveLightsInfoDTO saveLightsInfoDTO) {
        lightsConfigService.saveLightsInfo(saveLightsInfoDTO);
        JsonViewObject jsonViewObject = JsonViewObject.newInstance();

        return jsonViewObject.success();
    }

    @ApiOperation(value = "灯组配置列表", notes = "灯组配置列表", response = JsonViewObject.class,
            produces = MediaType.APPLICATION_JSON, consumes = MediaType.APPLICATION_JSON)
    @PostMapping(value = "/listLightsInfo",
            produces = MediaType.APPLICATION_JSON, consumes = MediaType.APPLICATION_JSON)
    @ApiResponses({
            @ApiResponse(code = 200, message = "OK", response = SaveLightsInfoDTO.class),
    })
    public JsonViewObject listLightsInfo(@RequestBody CrossIdDTO crossIdDTO) {
        SaveLightsInfoDTO saveLightsInfoDTO = lightsConfigService.listLightsInfo(crossIdDTO);
        JsonViewObject jsonViewObject = JsonViewObject.newInstance();

        return jsonViewObject.success(saveLightsInfoDTO);
    }

}
